#include <windows.h>
#include "VolumousePlugin.h"



BOOL WINAPI DllMain(
  HINSTANCE hinstDLL,
  DWORD fdwReason,
  LPVOID lpvReserved
)
{

	return TRUE;
}

WCHAR PluginName[] = L"MoveResize";
WCHAR ResizeComponentName[] = L"Resize Active Window";
WCHAR MoveHorComponentName[] = L"Move Active Window - Horizontal";
WCHAR MoveVerComponentName[] = L"Move Active Window - Vertical";
const int CHANGE_DIV = 500;

void MoveActiveWindowVer(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	int iChange = pEvent->UserAction.Change / CHANGE_DIV;

	HWND hActiveWindow = GetForegroundWindow();

	if (hActiveWindow != NULL)
	{
		RECT rect;

		GetWindowRect(hActiveWindow, &rect);
		SetWindowPos(hActiveWindow, NULL, rect.left, rect.top - iChange, rect.right - rect.left, rect.bottom - rect.top, SWP_NOZORDER);
	}
}

void MoveActiveWindowHor(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	int iChange = pEvent->UserAction.Change / CHANGE_DIV;

	HWND hActiveWindow = GetForegroundWindow();

	if (hActiveWindow != NULL)
	{
		RECT rect;

		GetWindowRect(hActiveWindow, &rect);
		SetWindowPos(hActiveWindow, NULL, rect.left + iChange, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_NOZORDER);
	}
	
}


void ResizeActiveWindow(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	int iChange = pEvent->UserAction.Change / CHANGE_DIV;

	HWND hActiveWindow = GetForegroundWindow();

	if (hActiveWindow != NULL)
	{
		RECT rect;

		GetWindowRect(hActiveWindow, &rect);
		SetWindowPos(hActiveWindow, NULL, rect.left - iChange, rect.top - iChange, rect.right - rect.left + iChange * 2, rect.bottom - rect.top + iChange * 2, SWP_NOZORDER);
	}

}


INT_PTR WINAPI VolumousePluginProc(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	INT_PTR result = FALSE;

	switch(pEvent->EventID)
	{
		case VOLUPLUGIN_EVENT_LOAD:
			//This event is fired when the plugin is loaded into Volumouse.

			pEvent->Load.PluginName = PluginName;
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_UNLOAD:
			//This event is fired when the plugin is unloaded from Volumouse.
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_ADD_COMPONENTS:
			//This event is fired when Volumouse need to display the components list.
			//Add our 3 components to the components list of Volumouse.
			pEvent->AddComponents.Count = 3;
			pEvent->AddComponents.Components[0] = ResizeComponentName;
			pEvent->AddComponents.Components[1] = MoveHorComponentName;
			pEvent->AddComponents.Components[2] = MoveVerComponentName;

			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_USER_ACTION:
			//This event is fired when the user moves the wheel or press
			//the hot key combination, according to the defined rules.

			if (pEvent->UserAction.ComponentIndex == 0)
			{
				//Resize active window
				ResizeActiveWindow(pEvent);
				result = TRUE;
			}
			else if (pEvent->UserAction.ComponentIndex == 1)
			{
				//Move Active Window - Horizontal
				MoveActiveWindowHor(pEvent);
				result = TRUE;
			}
			else if (pEvent->UserAction.ComponentIndex == 2)
			{
				//Move Active Window - Vertical
				MoveActiveWindowVer(pEvent);
				result = TRUE;
			}

			break;
	}

	return result;
}